code	segment	'code'
	assume	cs:code,ds:code

	org	100h

start:	mov	sp,200h			; move stack pointer
	push	ax

	mov	bx,20h			; resize memory block
	mov	ah,4ah
	int	21h

	mov	ax,3521h		; get old handler
	int	21h
	mov	word ptr old21,bx
	mov	word ptr old21+2,es
	push	cs			; restore ES for EXEC
	pop	es

	mov	dx,offset new21		; install new handler
	mov	ah,25h
	int	21h

	mov	word ptr tail+2,cs	; set param block segments
	mov	word ptr fcb1+2,cs
	mov	word ptr fcb2+2,cs

	mov	dx,offset prog		; EXEC child process
	mov	bx,offset parm
	mov	ax,4b00h
	int	21h

	mov	dx,word ptr old21	; restore old handler
	mov	ds,word ptr old21+2
	mov	ax,2521h
	int	21h

	ret

new21:	cmp	ax,5700h		; get file date/time stamp?
	jne	int21
	pushf				; call old handler
	push	cs
	call	int21
	jc	err			; do nothing on error
	mov	cx,4040h		; report specific time stamp
err:	iret

int21:	db	0eah			; far jump opcode
old21	dd	0

prog	db	'BAD.EXE'		; program filename
parm	dw	0			; default env seg
tail	dd	80h			; command line tail pointer
fcb1	dd	5ch			; first FCB pointer
fcb2	dd	6ch			; second FCB pointer

code	ends

	end	start
